package net.jaekl.cfb.db;

public class Column {
	public enum Type {
		CHAR, INTEGER, TIMESTAMP, TIMESTAMPTZ, VARCHAR 
	};
	public enum Null {
		NOT_NULL, NULL
	}
	
	String m_name;
	Type m_type;
	int m_width;
	Null m_null;
	
	public Column(String name, Type type, int width, Null canBeNull) 
	{
		m_name = name;
		m_type = type;
		m_width = width;
		m_null = canBeNull;
	}
	
	public String getName() { return m_name; }
	public Type getType() { return m_type; }
	public int getWidth() { return m_width; }
	public Null getNull() { return m_null; }
	
	// Create a column based on an array of Objects
	// Input format:  { name, type, width, can_be_null } 
	public static Column construct(Object[] spec) {
		assert(null != spec);
		assert(4 == spec.length);
		assert(spec[0] instanceof String);
		assert(spec[1] instanceof Type);
		assert(spec[2] instanceof Number);
		assert(spec[3] instanceof Null);
		
		String name = (String)(spec[0]);
		Type type = (Type)(spec[1]);
		Number width = (Number)(spec[2]);
		Null canBeNull = (Null)(spec[3]);
		
		return new Column(name, type, width.intValue(), canBeNull);
	}
}
