package net.jaekl.cfb.db;

import java.util.ArrayList;
import java.util.Arrays;

public class Table {
	String m_name;
	ArrayList<Column> m_columns;
	
	public Table(String name, Column[] columns) {
		m_name = name;
		m_columns = new ArrayList<Column>(Arrays.asList(columns));		
	}
	
	public String getName() { return m_name; }
	public int getNumColumns() { return m_columns.size(); }
	public Column getColumn(int idx) { return m_columns.get(idx); }
	
	// Construct a table from an array of objects like this:
	// {
	//   { table_name },
	//   { column_name, type, width (-1 for default), null/not_null }
	// }
	public static Table construct(Object[][] spec) 
	{
		assert(null != spec);
		assert(spec.length > 1);
		assert(1 == spec[0].length);
		assert(spec[0][0] instanceof String);
		
		String name = (String)(spec[0][0]);
		Column[] columns = new Column[spec.length - 1];
		
		for (int idx = 1; idx < spec.length; ++idx) {
			columns[idx - 1] = Column.construct(spec[idx]);
		}
		
		return new Table(name, columns);
	}
}
